#version 430 core
/*
* Copyright 2019 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal_in;
layout(location = 2) in vec2 texture_coord_in;

out VertexData {
	vec3 position_world;
	vec3 Normal;
	vec2 texture_coord;
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;

void main() {
	// gl_Position is a built-in variable
	gl_Position = viewProjMatrix * modelMatrix * vec4(position, 1);
	vert.position_world = vec3(modelMatrix * vec4(position, 1));
	vert.Normal = normal_in;
	vert.texture_coord = texture_coord_in;
}